import React from 'react';
import { InputProps } from '../input/input';
export declare type CardInputProps = InputProps & {
    /** Подсказка в текстовом поле */
    placeholder?: string;
};
/**
 * Поле ввода номера карты с маской.
 */
export declare class CardInput extends React.PureComponent<CardInputProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<CardInputProps>;
    /**
     * @type {Input}
     */
    root: any;
    render(): JSX.Element;
    /**
     * Устанавливает фокус на поле ввода.
     */
    focus(): void;
    /**
     * Убирает фокус с поля ввода.
     */
    blur(): void;
    /**
     * Скроллит страницу до поля ввода.
     */
    scrollTo(): void;
}
declare const _default: React.ForwardRefExoticComponent<InputProps & {
    /** Подсказка в текстовом поле */
    placeholder?: string;
} & React.RefAttributes<CardInput>> & CardInput;
export default _default;
