import React from 'react';
export declare type FlagIconProps = {
    /**
     * Код страны из <a href="https://ru.wikipedia.org/wiki/ISO_3166-1_alpha-2" target="_blank">ISO 3166-1 alpha-2</a>
     */
    country?: string;
    /**
     * Режим отображения
     */
    mode?: 'chunk' | 'sprite';
    /**
     * Управление наличием тени у компонента
     */
    isFlat?: boolean;
    /**
     * Дочерние элементы `FlagIcon`
     */
    children?: React.ReactNode;
    /**
     * Размер компонента
     */
    size?: 's' | 'm' | 'l' | 'xl';
    /**
     * Тема компонента
     */
    theme?: 'alfa-on-color' | 'alfa-on-white';
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Компонент флага в виде иконки.
 */
export declare class FlagIcon extends React.PureComponent<FlagIconProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<FlagIconProps>;
    render(): JSX.Element;
}
declare const _default: React.ForwardRefExoticComponent<FlagIconProps & React.RefAttributes<FlagIcon>> & FlagIcon;
export default _default;
