import React from 'react';
import { Theme } from '../cn';
export declare type FormFieldProps = {
    /**
     * Дочерние элементы `FormField`
     */
    children?: React.ReactNode;
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Размер компонента
     */
    size?: 's' | 'm' | 'l' | 'xl';
    /**
     * Тема компонента
     */
    theme?: Theme;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Компонент поля формы.
 * Необходим для вертикального ритма в форме.
 */
export declare class FormField extends React.PureComponent<FormFieldProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<FormFieldProps>;
    render(): JSX.Element;
}
declare const _default: React.ForwardRefExoticComponent<FormFieldProps & React.RefAttributes<FormField>> & FormField;
export default _default;
