import React from 'react';
import { Theme } from '../cn';
export declare type HeadingProps = {
    /**
     * Дочерние элементы `Heading`
     */
    children?: React.ReactNode;
    /**
     * Размер, определяющий какой тег заголовка будет использоваться
     */
    size?: 'xs' | 's' | 'm' | 'l' | 'xl';
    /**
     * Дефолтные отступы
     */
    hasDefaultMargins?: boolean;
    /**
     * Тема компонента
     */
    theme?: Theme;
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Компонент заголовка.
 */
export declare class Heading extends React.PureComponent<HeadingProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<HeadingProps>;
    render(): React.ReactElement<{
        className: string;
        id: string;
        'data-test-id': string;
    }, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)>) | (new (props: any) => React.Component<any, any, any>)>;
}
declare const _default: React.ForwardRefExoticComponent<HeadingProps & React.RefAttributes<Heading>> & Heading;
export default _default;
