"use strict";
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.IsolatedContainer = void 0;
var react_1 = __importDefault(require("react"));
/**
 * Изолирует своих детей от изменений `props`-ов, и `context`-а.
 * Используется для визуализации элементов в кастомных контейнерах,
 * о которых React не должен ничего знать.
 */
var IsolatedContainer = /** @class */ (function (_super) {
    __extends(IsolatedContainer, _super);
    function IsolatedContainer() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    IsolatedContainer.prototype.shouldComponentUpdate = function () {
        return false;
    };
    IsolatedContainer.prototype.render = function () {
        var _this = this;
        return (react_1.default.createElement("div", { ref: function (element) {
                _this.element = element;
            } }));
    };
    /**
     * Возвращает корневой `HTMLElement` компонента.
     */
    IsolatedContainer.prototype.getNode = function () {
        return this.element;
    };
    return IsolatedContainer;
}(react_1.default.Component));
exports.IsolatedContainer = IsolatedContainer;
exports.default = IsolatedContainer;

//# sourceMappingURL=isolated-container.js.map
