import React from 'react';
import { Theme } from '../cn';
export declare type LabelProps = {
    /**
     * Размер компонента
     */
    size?: 's' | 'm' | 'l' | 'xl' | '2xl' | '3xl' | '4xl';
    /**
     * Дочерние элементы `Label`
     */
    children?: React.ReactNode;
    /**
     * Тема компонента
     */
    theme?: Theme;
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Управление возможностью рендерить компонент в одну сроку
     */
    isNoWrap?: boolean;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Компонента лейбла.
 */
export declare class Label extends React.PureComponent<LabelProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<LabelProps>;
    render(): JSX.Element;
}
declare const _default: React.ForwardRefExoticComponent<LabelProps & React.RefAttributes<Label>> & Label;
export default _default;
