import React from 'react';
export declare type ListHeaderProps = {
    /**
     * Заголовок
     */
    title?: React.ReactNode;
    /**
     * Комментарий
     */
    description?: React.ReactNode;
    /**
     * Тема компонента
     */
    theme?: 'alfa-on-color' | 'alfa-on-white';
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Вид компонента
     */
    view?: 'transparent' | 'filled';
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Компонент для разделения списка по датам или смысловым группам.
 */
export declare class ListHeader extends React.PureComponent<ListHeaderProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    render(): JSX.Element;
}
declare const _default: React.ForwardRefExoticComponent<ListHeaderProps & React.RefAttributes<ListHeader>> & ListHeader;
export default _default;
