import React from 'react';
import { Theme } from '../cn';
declare type ListItemsType = {
    /**
     * Уникальный ключ элемента
     */
    key: string;
    /**
     * Содержание элемента
     */
    value: React.ReactNode;
    /**
     * Вложенный список элементов
     */
    list?: readonly ListItemsType[];
};
export declare type ListProps = {
    /**
     * Список элементов
     */
    items?: readonly ListItemsType[];
    /**
     * Тип списка
     */
    type?: 'default' | 'ordered';
    /**
     * Тема компонента
     */
    theme?: Theme;
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Компонент списка.
 */
export declare class List extends React.Component<ListProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    render(): React.DetailedReactHTMLElement<{
        className: string;
        id: string;
        'data-test-id': string;
    }, HTMLElement>;
}
declare const _default: React.ForwardRefExoticComponent<ListProps & React.RefAttributes<List>> & List;
export default _default;
