"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var match_media_1 = require("../lib/match-media");
/**
 * Хук для медиа запросов.
 */
function useMedia(query) {
    var _a = react_1.useState(function () { return match_media_1.getMatchMedia(query).matches; }), matches = _a[0], setMatches = _a[1];
    react_1.useEffect(function () {
        var mql = match_media_1.getMatchMedia(query);
        function handleMatchChange() {
            setMatches(mql.matches);
        }
        handleMatchChange();
        mql.addListener(handleMatchChange);
        return function () {
            match_media_1.releaseMatchMedia(query);
            mql.removeListener(handleMatchChange);
        };
    }, [query]);
    return matches;
}
exports.default = useMedia;

//# sourceMappingURL=useMedia.js.map
