import React from 'react';
import { InputProps } from '../input/input';
export declare type PhoneInputProps = InputProps & {
    /**
     * Определяет маску для ввода значений.
     * <a href="https://github.com/insin/inputmask-core#pattern" target="_blank">Шаблон маски</a>
     */
    mask?: string;
    /**
     * Подсказка в текстовом поле
     */
    placeholder?: string;
};
declare type PhoneInputState = {
    updatedValue?: string;
};
/**
 * Компонент ввода телефона по маске.
 */
export declare class PhoneInput extends React.PureComponent<PhoneInputProps, PhoneInputState> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<PhoneInputProps>;
    state: {
        updatedValue: any;
    };
    root: any;
    render(): JSX.Element;
    /**
     * Промежуточный обработчик value после изменения значения.
     * В value проверяется, что первый числовой символ 7,
     * если 7, то ничего не делаем
     * если 8, то происходит замена на 7
     * иначе вставляем 7, а остальное сдвигаем
     */
    private handleChange;
    static shiftValue(originalValue: string, mask?: string): string;
    /**
     * Устанавливает фокус на поле ввода.
     */
    focus(): void;
    /**
     * Убирает фокус с поля ввода.
     */
    blur(): void;
    /**
     * Скроллит страницу до поля ввода.
     */
    scrollTo(): void;
}
declare const _default: React.ForwardRefExoticComponent<InputProps & {
    /**
     * Определяет маску для ввода значений.
     * <a href="https://github.com/insin/inputmask-core#pattern" target="_blank">Шаблон маски</a>
     */
    mask?: string;
    /**
     * Подсказка в текстовом поле
     */
    placeholder?: string;
} & React.RefAttributes<PhoneInput>> & PhoneInput;
export default _default;
