import React from 'react';
import { Theme } from '../cn';
export declare type PopupHeaderProps = {
    /**
     * Размер компонента
     */
    size?: 's' | 'm' | 'l' | 'xl';
    /**
     * Содержимое заголовка
     */
    title?: React.ReactNode;
    /**
     * Тема компонента
     */
    theme?: Theme;
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Обработчик клика по кнопке закрытия
     */
    onCloserClick?: (event?: React.MouseEvent<any>) => void;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Заголовок в Popup.
 */
export declare class PopupHeader extends React.PureComponent<PopupHeaderProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    render(): JSX.Element;
    private handleCloserClick;
}
declare const _default: React.ForwardRefExoticComponent<PopupHeaderProps & React.RefAttributes<PopupHeader>> & PopupHeader;
export default _default;
