"use strict";
/* This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PopupHeader = void 0;
var react_1 = __importDefault(require("react"));
var bem_react_classname_1 = require("bem-react-classname");
var icons_classic_1 = require("@alfalab/icons-classic");
var cn_1 = require("../cn");
var icon_button_1 = __importDefault(require("../icon-button/icon-button"));
/**
 * Заголовок в Popup.
 */
var PopupHeader = /** @class */ (function (_super) {
    __extends(PopupHeader, _super);
    function PopupHeader() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.cn = bem_react_classname_1.createCn('popup-header');
        _this.handleCloserClick = function (event) {
            if (_this.props.onCloserClick) {
                _this.props.onCloserClick(event);
            }
        };
        return _this;
    }
    PopupHeader.prototype.render = function () {
        var _a = this.props, size = _a.size, id = _a.id, dataTestId = _a["data-test-id"], title = _a.title;
        var closeIcons = {
            xs: icons_classic_1.CloseXsIcon,
            s: icons_classic_1.CloseSIcon,
            m: icons_classic_1.CloseMIcon,
            l: icons_classic_1.CloseLIcon,
            xl: icons_classic_1.CloseXlIcon,
        };
        var IconClose = closeIcons[size || 'm'];
        return (react_1.default.createElement("div", { className: this.cn({
                size: size,
            }), id: id, "data-test-id": dataTestId },
            react_1.default.createElement(icon_button_1.default, { className: this.cn('closer'), size: size, onClick: this.handleCloserClick },
                react_1.default.createElement(IconClose, null)),
            react_1.default.createElement("div", { className: this.cn('title') }, title)));
    };
    return PopupHeader;
}(react_1.default.PureComponent));
exports.PopupHeader = PopupHeader;
exports.default = cn_1.withTheme(PopupHeader);

//# sourceMappingURL=popup-header.js.map
