/// <reference types="react" />
/**
 * Высчитывает координаты блока, который является таргетом поп-апа.
 *
 * @param {PopupHash} popup Набор параметров попапа
 * @returns {Rect}
 */
export declare function calcTargetDimensions(popup: any): {
    left: any;
    top: any;
    width: any;
    height: any;
};
/**
 * Определяет контейнер, в котором рендерится Popup и возвращает его размеры и координаты.
 *
 * @param {PopupHash} popup Набор параметров попапа
 * @returns {Rect}
 */
export declare function calcFitContainerDimensions(popup: any): {
    top: any;
    left: any;
    bottom: any;
    right: any;
};
/**
 * Рассчитывает наилучшие значения для позиционирования Popup.
 *
 * @param {PopupHash} popup Набор параметров попапа
 * @param {Rect} targetDimensions Область отрисовки якорного элемента
 * @param {Rect} fitContainerDimensions Размеры вьюпорта
 * @returns {DrawingParams}
 */
export declare function calcBestDrawingParams(popup: any, targetDimensions: any, fitContainerDimensions: any): {
    direction: string;
    left: any;
    top: any;
    height: import("react").Key;
    overflow: boolean;
};
