import React from 'react';
export declare type ProgressBarProps = {
    /**
     * Прогресс в процентах
     */
    percent?: number;
    /**
     * Размер компонента
     */
    size?: 'm';
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Тема компонента
     */
    theme?: 'alfa-on-color' | 'alfa-on-white';
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Компонент прогресс-бара.
 */
export declare class ProgressBar extends React.PureComponent<ProgressBarProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<ProgressBarProps>;
    render(): JSX.Element;
}
declare const _default: React.ForwardRefExoticComponent<ProgressBarProps & React.RefAttributes<ProgressBar>> & ProgressBar;
export default _default;
