import React from 'react';
export declare type SidebarProps = {
    /**
     * Тема компонента
     */
    theme?: 'alfa-on-color' | 'alfa-on-white';
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Дочерние компоненты
     */
    children?: React.ReactNode;
    /**
     * Признак для отрисовки элемента закрытия
     */
    hasCloser?: boolean;
    /**
     * Признак для отрисовки оверлея
     */
    hasOverlay?: boolean;
    /**
     * Признак появления сайдбара
     */
    visible: boolean;
    /**
     * Контент в шапке сайдбара
     */
    headerContent?: React.ReactNode;
    /**
     * Контент в подвале сайдбара, на мобильных устройствах содержимое футера прижимается к нижней части вьюпорта
     */
    footerContent?: React.ReactNode;
    /**
     * Ширина сайдбара
     */
    width?: number;
    /**
     * Обработчик клика на элемент закрытия
     */
    onCloserClick?: (event?: React.MouseEvent<any> | KeyboardEvent) => void;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
declare type SidebarState = {
    isMobile: boolean;
};
/**
 * Компонент боковой панели aka холодильник.
 */
export declare class Sidebar extends React.PureComponent<SidebarProps, SidebarState> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<SidebarProps>;
    state: {
        isMobile: boolean;
    };
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    renderHeaderContent(): JSX.Element;
    private handleMqMatchChange;
    private handleClose;
    private handleKeyDown;
    private styleBodyRightMargin;
}
declare const _default: React.ForwardRefExoticComponent<SidebarProps & React.RefAttributes<Sidebar>> & Sidebar;
export default _default;
