import React from 'react';
import { Theme } from '../cn';
export declare type SpinProps = {
    /**
     * Управление видимостью компонента
     */
    visible?: boolean;
    /**
     * Размер компонента
     */
    size?: 's' | 'm' | 'l' | 'xl';
    /**
     * Тема компонента
     */
    theme?: Theme;
    /**
     * Дочерние элементы `Spin`
     */
    children?: React.ReactNode;
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Идентификатор компонента в DOM
     */
    id?: string;
    /**
     * Идентификатор для систем автоматизированного тестирования
     */
    'data-test-id'?: string;
};
/**
 * Компонент показывающий крутящееся кольцо загрузки.
 */
export declare class Spin extends React.PureComponent<SpinProps> {
    protected cn: (this: void | {
        props?: Record<string, unknown>;
    }, elementNameOrMods?: string | {
        [key: string]: string | number | boolean;
    }, mods?: {
        [key: string]: string | number | boolean;
    }) => string;
    static defaultProps: Partial<SpinProps>;
    render(): JSX.Element;
}
declare const _default: React.ForwardRefExoticComponent<SpinProps & React.RefAttributes<Spin>> & Spin;
export default _default;
