import React from 'react';
import Type from 'prop-types';
import { Theme } from '../cn';
export declare type ThemeProviderProps = {
    /**
     * Дочерний элемент `ThemeProvider`
     */
    children?: React.ReactNode;
    /**
     * Дополнительный класс
     */
    className?: string;
    /**
     * Тема компонента
     */
    theme?: Theme;
};
/**
 * Компонент задающий тему для своих дочерних компонентов.
 * Важно! Может содержать в себе строго один дочерний компонент.
 */
declare class ThemeProvider extends React.Component<ThemeProviderProps> {
    static contextTypes: {
        theme: Type.Requireable<string>;
    };
    static childContextTypes: {
        theme: Type.Requireable<string>;
    };
    getChildContext(): {
        theme: Theme;
    };
    render(): JSX.Element;
}
export default ThemeProvider;
